/**
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2011
 */
define('oxguard/register', ['io.ox/core/extensions', 'oxguard/oxguard_core', 'io.ox/core/notifications',
                           'gettext!oxguard/register', 'css!oxguard/style.css'],
                           function (ext, oxguard, notify, gt) {
    'use strict';
    
    
    var oxguarddata = {
            passcode : null,
            settings:  {},
            version: '1.0.0-0'
        };
    window.oxguarddata = oxguarddata;
    
    // Login section
    if (sessionStorage !== null) {// If we were passed login info from login screen
        sendauth(sessionStorage.oxguard === undefined ? '' : sessionStorage.oxguard);
        sessionStorage.oxguard = null;// null out the sessionStorage
    } else sendauth('');
    
   
    function sendauth(pass)
    {
        oxguard.auth(ox.user_id, pass)
        .done(function (data) {
            if (data.auth.length > 20) {// If good code comes back, then store userid
                oxguarddata.userid = ox.user_id;
                oxguarddata.passcode = data.auth;
                $('.og_signout').show();
            } else {// If bad code, then log and mark oxguard.user_id as -1
                if ((data.auth.indexOf('Bad') > -1) || (data.auth.indexOf('Lockout') > -1)) {
                    oxguarddata.passcode = null;
                } else {
                    oxguarddata.passcode = data.auth;
                }
                oxguarddata.userid = -1;
            }
            if (ox.context_id === 0) ox.context_id = data.cid; // If the cid wasn't loaded, update from backend
            oxguarddata.settings = data.settings; // user settings
            oxguarddata.lang = data.lang;// Languages available
            oxguarddata.baton = window.oxguarddata.baton;
            window.oxguarddata = oxguarddata;
            if (window.oxguarddata.baton !== undefined) {
                require(['oxguard/register_mail'], function (mail) {
                    mail.checkOG(window.oxguarddata.baton);
                });
                window.oxguarddata.baton = undefined;
            }
        })
        .fail(function () {
            $('.og_signout').hide();
        	console.debug('Unable to connect to the encryption server');
        });
    }

    ext.point('io.ox/core/logout').extend({
        id: 'logoutOG',
        logout: function () {
            // force save requests for all pending settings
            $.get(ox.apiRoot + '/oxguard/login?action=logout', function () {
                window.oxguarddata = null;
            })
            .fail(function () {
                console.log('Fail logout oxguard');
            });
            
        }
    });
 
    ext.point('io.ox/core/topbar/right/dropdown').extend({
        id: 'logoutOG',
        index: 990,
        draw: function () {
            this.append(
                $('<li class="divider og_signout" aria-hidden="true" role="presentation"></li>'),
                $('<li class="og_signout">').append(
                    $('<a href="#" data-action="logout" role="menuitem" tabindex="1">').text(gt('Sign out Guard'))
                )
                .on('click', function (e) {
                    e.preventDefault();
                    window.oxguarddata.passcode = null;
                    $('.og_signout').hide();
                })
            );
            var auth = window.oxguarddata.passcode;
            if (auth === null) {
                hideLogout();
                return;
            }
            if (auth.length < 20) hideLogout();
            
        }
    });
    
    function hideLogout() {
        window.setTimeout(function () {
            $('.og_signout').hide();
        },100);
    }
    


    
 
});
